.586
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
EditProc    PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib


.const

MainWindowWidth         equ             400
MainWindowHeight        equ             300
NoButtons               equ             3
.data

hInstance       DWORD           ?
CommandLine     LPSTR           ?

hMainWindow     dd              ?
MainWindowClass db              'MainWindowClass',0
MainWindowName  db              'RichEdit Control',0

RichEditClass           db              'RichEdit20A',0
szLibRichEdit           db              'c:\windows\system32\riched20.dll',0
hRichEdit               dd              ?

ToolbarClass    db      'ToolbarWindow32',0
hToolbar        dd          ?
TBButtons       TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <0,1,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <0,2,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
rect                    RECT                  <>
lpOldEditProc   dd      ?
EditStream      EDITSTREAM          <0,0,offset EditStreamCallBack>
Text1           db      'riched.asm',0
Text2           db      '.\riched.obj',0
Text3           db      '.\riched.exe',0
CharFormat  CHARFORMAT  <sizeof CharFormat,CFM_BOLD+CFM_FACE+CFM_SIZE,CFE_BOLD,200,\
                        NULL,NULL,NULL,NULL,'Arial'>
szArial         db      'Arial',0
                        
.code
        start:
                invoke  GetModuleHandle,NULL
                mov     hInstance,eax
                invoke  GetCommandLine
                mov     CommandLine,eax
                invoke  InitCommonControls
                invoke  LoadLibrary,addr szLibRichEdit
                invoke  WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
                invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

        local   wc:WNDCLASSEX
        local   msg:MSG

        mov     wc.cbSize,sizeof wc
        mov     wc.style,CS_HREDRAW+CS_VREDRAW
        mov     wc.lpfnWndProc,offset WndProc
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,offset MainWindowClass
        mov     wc.cbClsExtra,NULL
        mov     wc.cbWndExtra,NULL
        mov     wc.hbrBackground,COLOR_WINDOW
        push    hInst
        pop     wc.hInstance
        invoke  LoadIcon,NULL,IDI_APPLICATION
        mov     wc.hIcon,eax
        mov     wc.hIconSm,eax
        invoke  LoadCursor,NULL,IDC_ARROW
        mov     wc.hCursor,eax
        invoke  RegisterClassEx,addr wc
        invoke  GetSystemMetrics,SM_CYSCREEN
        shr     eax,1
        sub     eax,MainWindowHeight/2
        push    eax
        invoke  GetSystemMetrics,SM_CXSCREEN
        shr     eax,1
        sub     eax,MainWindowWidth/2
        pop     ebx
        invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
        mov     hMainWindow,eax
        invoke  ShowWindow,eax,SW_SHOWNORMAL
        invoke  UpdateWindow,hMainWindow

        .while  TRUE

                invoke  GetMessage,addr msg,NULL,0,0

        .break .if (!eax)

                invoke  TranslateMessage,addr msg
                invoke  DispatchMessage,addr msg

        .endw

        mov     eax,msg.wParam
        ret

WinMain endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

        .if     uMsg==WM_DESTROY

                invoke  PostQuitMessage,NULL
        .elseif uMsg==WM_CREATE
                mov     edi,lParam
                .if     [edi.CREATESTRUCT].hWndParent==NULL
                        invoke  GetClientRect,hWnd,addr rect
                        add     rect.top,34
                        sub     rect.bottom,32
                        invoke  CreateWindowEx,NULL,addr RichEditClass,NULL,WS_VISIBLE+WS_CHILD+ES_SUNKEN+ES_WANTRETURN,\
                                        0,rect.top,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
                        mov     hRichEdit,eax
                        invoke  CreateWindowEx,NULL,addr ToolbarClass,NULL,WS_VISIBLE+WS_CHILD+TBSTYLE_FLAT,\
                                    0,0,0,0,hWnd,NULL,hInstance,NULL
                        mov     hToolbar,eax
                        invoke  SendMessage,hToolbar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
                        invoke  SendMessage,hToolbar,TB_SETBUTTONSIZE,200020h,NULL
                        invoke  SendMessage,hToolbar,TB_ADDBUTTONS,NoButtons,addr TBButtons
                        invoke  SendMessage,hToolbar,TB_AUTOSIZE,NULL,NULL                                    
                    ;    invoke  SetWindowLong,hRichEdit,GWL_WNDPROC,addr EditProc
                    ;    mov     lpOldEditProc,eax 
                        invoke SendMessage,hRichEdit,EM_SETBKGNDCOLOR,0,0FF0000h 
                        lea esi,szArial
                        lea edi,CharFormat.szFaceName
                        cld
looper:
                        lodsb
                        cmp al,0
                        je  end_looper
                        stosb
                        jmp looper
end_looper:
                        stosb                                              
                        invoke  SendMessage,hRichEdit,EM_SETCHARFORMAT,SCF_ALL,addr CharFormat           
                .endif 
        .elseif     uMsg==WM_COMMAND
            mov eax,wParam
          ;  rol eax,16
            invoke  SendMessage,hRichEdit,EM_SETTARGETDEVICE,NULL,NULL
            .if ax==0
                invoke  CreateFile,addr Text1,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,\
                            FILE_ATTRIBUTE_NORMAL,NULL
                .if eax==INVALID_HANDLE_VALUE
                    invoke  Beep,200,20                            
                .endif                    
             ;   invoke  SendMessage,hRichEdit,EM_SETMODIFY,FALSE,NULL
                mov     EditStream.dwCookie,eax
                invoke  SendMessage,hRichEdit,EM_STREAMIN,SF_TEXT,addr EditStream
            .elseif ax==1
                mov     EditStream.dwCookie,offset Text2
                invoke  SendMessage,hRichEdit,EM_STREAMIN,SF_RTF,addr EditStream
            .elseif ax==2                                                                  
                mov     EditStream.dwCookie,offset Text3
                invoke  SendMessage,hRichEdit,EM_STREAMIN,SF_RTF,addr EditStream
            .endif      
                invoke  SendMessage,hRichEdit,EM_SETMODIFY,NULL,NULL          
        .else

                invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
                ret

        .endif

        xor     eax,eax
        ret

WndProc endp

EditProc    PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if uMsg==WM_KEYDOWN
            
    .endif
    invoke  CallWindowProc,lpOldEditProc,hWnd,uMsg,wParam,lParam
    ret

EditProc    endp       

EditStreamCallBack  PROC    dwCookie:DWORD,lpBuff:DWORD,cb:DWORD,pcb:DWORD

    local       hFile:DWORD
    
 ;     pushad
 ;     pushfd
 ;     lea esi,Text1
 ;     mov edi,lpBuff
 ;     cld
 ; looper:
 ;     lodsb
 ;     cmp al,0
 ;     je  end_looper
 ;     stosb
 ;     jmp looper
 ; end_looper:
 ;     stosb
 ;     popfd
 ;     popad
 ;     mov eax,TRUE
 ;     ret
 ;              
    invoke  ReadFile,dwCookie,lpBuff,cb,pcb,NULL
    .if eax==NULL
        invoke  Beep,400,20
    .endif        
 ;   invoke  CloseHandle,hFile
    mov eax,TRUE
    ret 
EditStreamCallBack  endp 
    
end     start                                       